﻿using Modbus.Device;
using System;
using System.IO.Ports;

namespace ModbusLearn
{
	internal class Program
	{
		static void Main(string[] args)
		{
			SerialPort serialPort = new SerialPort();
			serialPort.PortName = "COM5";
			serialPort.BaudRate = 9600;
			serialPort.DataBits = 8;
			serialPort.Parity = Parity.None;
			serialPort.StopBits = StopBits.One;
			serialPort.Open();
			ModbusSerialMaster master = ModbusSerialMaster.CreateRtu(serialPort);

			byte slaveID = 1;
			ushort startAddress = 0;
			ushort numOfPoints = 5;
			var data = master.ReadInputs(slaveID, startAddress, numOfPoints);
			Console.WriteLine(data[0]);
			Console.ReadKey();


			//using (SerialPort port = new SerialPort("COM5"))
			//{
			//    // configure serial port
			//    port.BaudRate = 9600;
			//    port.DataBits = 8;
			//    port.Parity = Parity.None;
			//    port.StopBits = StopBits.One;
			//    port.Open();

			//    // Wrap the serial port
			//    var adapter = new SerialPortAdapter(port);

			//    // Create the factory
			//    var factory = new ModbusFactory();

			//    // Create Modbus Master
			//    IModbusMaster master = factory.CreateRtuMaster(adapter);

			//    byte slaveId = 1;
			//    ushort startAddress = 100;
			//    ushort[] registers = new ushort[] { 1, 2, 3 };

			//    // write three registers
			//    master.WriteMultipleRegisters(slaveId, startAddress, registers);

			//    Console.ReadKey();
			//}
		}
	}
}
